#include "MSP430F5529.h"
#include "HardwareConfig.h"
#include "Types.h"
#include "LCD20x4.h"
#include "SPI.h"
#include "Sensor.h"
#include "Timer.h"

void make_layout(void);
void pulse_enable(void);

void main(void) {
	WDTCTL = WDTPW + WDTHOLD;
	pulse_enable();
	SysLCD.Init();
	make_layout();
	spi_init();
	SysSensor.Init();
	SysSensor.SetMode(BOAT);
	timer_init(25);
	uint16 a = sizeof(SysLCD);
	a = sizeof(SysSensor);
	__bis_SR_register(LPM0_bits + GIE);
}

void pulse_enable(void) {
	P7DIR |= 0x80;						//	Set P7.7 as master clock monitor
	P7SEL |= 0x80;
	P6DIR |= 0x03;						//	Set P6 0&1 as GPIO for check
	P6OUT &= ~0x03;
}

void make_layout() {
	SysLCD.MoveTo(3, 0);
	SysLCD.Write("Wind direction", 20);
	SysLCD.MoveTo(11, 2);
	SysLCD.Write(223);					//	Japanese dakuon "maru" which looks like 
}

#pragma vector=TIMER0_B0_VECTOR
__interrupt void Timer0B0_interrupt(void) {
	int16 sensorval;
	_DINT();							//	Avoid nested interrupts
	P6OUT |= 0x01;						//	Lift fla before function
	pulse();							//	Show a pulse inside of a function
	P6OUT &= ~0x01;						//	Drop flag after the function
	P6OUT |= 0x01;						//	Lift fla before function
	SysLCD.Pulse();						//	Show a pulse inside of a function
	P6OUT &= ~0x01;						//	Drop flag after the function
	sensorval = SysSensor.Read();
	SysLCD.WriteIntVal(sensorval);
	_EINT();							//	Reenable interrupts
}

