#ifndef _HARDWARE_CONFIG_H_
#define _HARDWARE_CONFIG_H_

#include "Types.h"

//	A few constants
#define	CLOCK			1000000
#define	CLOCK_MHZ		1

#define	MILLISECOND		(CLOCK_MHZ * 1000)

//	Sensor related definitions
#define	SENSOR_CTRL_DIR	P1DIR
#define	SENSOR_CTRL_OUT	P1OUT
#define	SENSOR_RST		0x04
#define	SENSOR_RQ		0x08
//	LCD related definitions
#define	LCD_DATA_DIR	P3DIR
#define	LCD_DATA_OUT	P3OUT
#define	LCD_CTRL_DIR	P1DIR
#define	LCD_CTRL_OUT	P1OUT
//	LCD control signals
#define	LCD_E			0x10	//	Bit set to 0 for enable
#define	LCD_CD			0x20	//	Bit set to 0 for command, to 1 for data
#define	LCD_WR			0x40	//	Bit set to 0 for write, to 1 for read
#define	EN_DELAY		(2 * CLOCK_MHZ)		//	Delay should be 1200 ns. Set to 2us
#define CMD_DELAY		(35 * CLOCK_MHZ)	//	Total delay - 37 us
//	LCD commands
#define	LCD_CLEAR		0x01	//	Clears the LCD RAM
#define	LCD_HOME		0x02	//	Move to the home position
#define	LCD_MODE		0x04	//	Set the mode with the 2 following parameters
#define	LCD_DIR			0x02	//	Parameter of LCD_MODE
#define	LCD_SH			0x01	//	Parameter of LCD_MODE
#define	LCD_ONOFF		0x08	//	Set the display on or off, see following parameters
#define	LCD_DISP		0x04	//	Parameter of LCD_ONOFF
#define LCD_CURSOR		0x02	//	Parameter of LCD_ONOFF
#define LCD_CUR_BLINK	0x01	//	Parameter of LCD_ONOFF

//	definiton of the 4 working modes, combinations of W/R and C/D
#define	SET_WC()		LCD_CTRL_OUT &=	~LCD_WR; LCD_CTRL_OUT &= ~LCD_CD	//	Write Command
#define	SET_WD() 		LCD_CTRL_OUT &=	~LCD_WR; LCD_CTRL_OUT |= LCD_CD		//	Write Data
#define	SET_RC()		LCD_CTRL_OUT |=	LCD_WR; LCD_CTRL_OUT &= ~LCD_CD		//	Read busy flags & address
#define	SET_RD()		LCD_CTRL_OUT |=	LCD_WR; LCD_CTRL_OUT &= LCD_CD		//	Read data

void delay_ms(uint16 ms);
void pulse(void);


#endif
