#include "MSP430F5529.h"
#include "SPI.h"

//	SPI initialization
void spi_init() {
	SPI_SEL |= SPI_BITS;				//	Change the output assignment from GPIO output to SPI
	SPI_CTRL_DIR |= SPI_CS;				//	Set bit to output
	UCB1CTL1 |= UCSWRST;				//	Put SPI engine to reset mode in order to configure it.
	UCB1BRW = 2;						//	Max possible bit rate for current clock frequency
	UCB1CTL0 = UCSYNC	|				//	SPI is synchronous
		UCMST			|				//	Master mode
		UCMSB;							//	Transmit most significant bit first.
	UCB1CTL1 |= UCSSEL_2;				//	Select Sub Master clock (SMCLK)
		UCB1CTL1 &= ~UCSWRST;			//	Enable SPI engine
}

//	Simple send with flag polling
uint8 spi_write_byte(uint8 b) {
	uint8 retval;
	UCB1IFG &= ~UCTXIFG;
	UCB1TXBUF = b;						//	Send the parameter
	while(!(UCB1IFG & UCRXIFG));		//	Wait until byte is sent (and therefore something is received)
	retval = UCB1RXBUF;					//	Get received value
	return retval;						//	return received value
}
