#include "MSP430F5529.h"
#include "HardwareConfig.h"
#include "Sensor.h"
#include "SPI.h"

TW11Sensor SysSensor;

void TW11Sensor::Init() {
	SENSOR_CTRL_DIR |= (SENSOR_RST | SENSOR_RQ);
	SENSOR_CTRL_OUT |= SENSOR_RST;
	SENSOR_CTRL_OUT &= ~SENSOR_RQ;
	//	Reset the sensor
	SENSOR_CTRL_OUT &= ~SENSOR_RST;
	delay_ms(10);
	SENSOR_CTRL_OUT |= SENSOR_RST;
	mOffset = -1;
	mMode = PLANE;
}

int16 TW11Sensor::Read(void) {
	int32 acc;
	int16 retval;
	uint8 * retbuf = (uint8 *)(&retval);
	SPI_CTRL_OUT &= ~SPI_CS;
	retbuf[1] = spi_write_byte(0);
	retbuf[0] = spi_write_byte(0);
	SPI_CTRL_OUT |= SPI_CS;
	retval &= 0x03FF;					//	Truncate to 10 bits
	if(mOffset == -1) mOffset = retval;	//	Store the offset to calculate the 0.
	mRawVal = retval;
	retval -= mOffset;
	while(retval < 0) retval += 1024;	//	In case the offset correction yielded a negative value
	acc = 360;
	acc *= retval;
	acc /= 1024;
	retval = acc;
	if(mMode = BOAT) {
		if(retval > 179) retval -= 360;
	}
	return retval;
}
