#include "MSP430F5529.h"
#include "Timer.h"

//	Timer initialization (the only time we need to care about the timer is
//	at initialization. Then it will call interrupts regulrarly.
//	Careful: this assumes that the clock is 1 MHz. will not work for other
//	values.
void timer_init(uint8 ms) {
	if(ms > 60) ms = 60;
	TBCCTL0 = CCIE;						//	CCR0 interrupt enabled
	TBCCR0 = (ms * 1000) -1;			//	Timer period (1ms)
	TBCTL = TBSSEL_2 + MC_1 + TBCLR;	//	SMCLK, contmode, clear TBR
}
